<?php defined('_JEXEC') or die( 'Restricted access' );
/**
 * @version 2.0 $Id: CommentHtmlUtils.php,v 1.6 2010-02-13 13:34:32 neschkeh Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

class CommentHtmlUtils {
	
	public static function &getListForType($active=NULL){
		$type = array();
		self::addDataEntriesToList($type);
		$result = JHTML::_('select.genericlist',   $type, 'type', 'class="inputbox" size="1" ', 'value', 'text', $active );
		return $result;
	}
	
	public static function &getFilterListForType($active=NULL){
		$type = array();
		$type[] = JHTML::_('select.option',  '-1', '- '. JText::_('Select Type') .' -' );
		self::addDataEntriesToList($type);
		$filterListForType = JHTML::_('select.genericlist',   $type, 'filter_type', 'class="inputbox" size="1" onchange="submitform( );"', 'value', 'text', $active );
		return $filterListForType;  
	}
	
	private static function addDataEntriesToList(&$type){
		$type[] = JHTML::_('select.option',  '0', self::convertCommentTypeToDescription(0));
		$type[] = JHTML::_('select.option',  '1', self::convertCommentTypeToDescription(1));
		$type[] = JHTML::_('select.option',  '2', self::convertCommentTypeToDescription(2));
		$type[] = JHTML::_('select.option',  '3', self::convertCommentTypeToDescription(3));
		$type[] = JHTML::_('select.option',  '4', self::convertCommentTypeToDescription(4));
	}

	public static function convertCommentTypeToDescription($type){
		switch ($type){
			case 1:
				return JText::_('R1 DEAD LINK');
			case 2:
				return JText::_('R2 INCORRECT DESCRIPTION');
			case 3:
				return JText::_('R3 WRONG CATEGORY'); 
			case 4:
				return JText::_('R4 OTHER');
			case 0:
				return JText::_('R0 COMMENT');
			default:
				return JText::_('RX NO REASON');
		}
	}

	// =======================================================================
	// = Kopie aus components/com_linkdirectory2
	// =======================================================================
	/**
	 * Liefert true, wenn das Kommentar-System 
	 * - eingeschaltet und 
	 * - auf internal gesetzt 
	 * ist, ansonsten false.
	 *
	 * @return true, wenn das Kommentar-System eingeschaltet und auf internal gesetzt ist, sonst false
	 */
	public static function isInternActive(){
		require_once JPATH_COMPONENT_ADMINISTRATOR.DS.'LDConfig.php';
		$ld = new LDConfig();
		return $ld->commentlink && ($ld->commentSystem == 'intern');
	}
	
	
}


?>