<?php defined('_JEXEC') or die('Restricted access');

/**
 * @version 2.0 $Id: controller.php,v 1.27 2010-02-17 21:53:09 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

jimport('joomla.application.component.controller');

require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'LDConfig.php');
require_once(JPATH_COMPONENT.DS.'classes'.DS.'LinkdirectoryURL.php');
require_once JPATH_COMPONENT.DS.'models'.DS.'comment.php';
require_once JPATH_COMPONENT.DS.'models'.DS.'log.php';

class LinkDirectory2Controller extends JController {

	const MODEL_WEBLINK = 'link';
	const URL_ROOT = 'index.php?option=com_linkdirectory2';
	const URL_WEBLINK = 'index.php?option=com_linkdirectory2&view=link';
	const URL_WEBCATEGORIES = 'index.php?option=com_linkdirectory2&view=categories';
	
	/* Task-Namen */
	const VIEW_WEBLINK = 'link';
	const VIEW_WEBCATEGORIES = 'categories';

	function display() {
		parent::display();
	}
	
	function search(){
		parent::display();
	}
	/**
	 * 
	 */
	public function addWebLink() {
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		require_once JPATH_COMPONENT.DS.'classes'.DS.'ViewUtils.php';
		if ( ! ViewUtils::isAddNewLinkAllowedForCurrentUser()){
			$msg = JText::_('ADD LINK IS NOT ALLOWED FOR CURRENT USER');
			$this->redirectToSourceUrl($msg);
			return;
		}
		
		$mainframe = JFactory::getApplication();
		require_once JPATH_COMPONENT.DS.'classes'.DS.'CaptchaUtils.php';
		$reloadPage = false;
		$checkSecurity = CaptchaUtils::validateCaptcha();
		if (!$checkSecurity) {
			$mainframe->enqueueMessage(JText::_('LD_LINK_REFUSED'));
			$reloadPage = true;	
		} else {
			$post	= JRequest::get('post');
			$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
			$post['id'] = (int) $cid[0];
			$weblink = & JTable::getInstance('link','Table');
			if (!$weblink->bind(JRequest::get('post'))) {
				JError::raiseError( 500, $db->stderr() );
				return false;
			}
			if (!$weblink->check()){ 
				$mainframe->enqueueMessage($weblink->getError() == '' ? JText::_('LD_MISSING_A_FIELD') : $weblink->getError());
				$reloadPage = true;
			}
		}
		if ($reloadPage){
			JRequest::setVar( 'view'  , 'link' );
			JRequest::setVar( 'task'  , 'add' );
			JRequest::setVar( 'cid', JRequest::getInt('cid',0));
			JRequest::setVar( 'source',JRequest::getString('source',0));
			JRequest::setVar( 'sid',JRequest::getInt('sid',0));
			parent::display();
			return;
		}
		$model = $this->getModel(self::MODEL_WEBLINK);
		$storeResult = $model->store($post);
		if ($storeResult) {
			if ($model->getData()->published){
				$msg = JText::_('WEBLINK SAVED AND PUBLISHED');
			} else {
				$msg = JText::_('WEBLINK SAVED');
			}
		} else {
			$msg = JText::_('ERROR SAVING WEBLINK');
		}
		$this->redirectToSourceUrl($msg);
	}
	
	public function cancelWebLink(){	
		$this->redirectToSourceUrl();	
	}
	
	private function redirectToSourceUrl($msg){
		$source = JRequest::getString('source','categories');
		$sid = JRequest::getInt('sid',0);
		switch ($source) {
			case self::VIEW_WEBLINK:
				$redirectUrl = LinkdirectoryURL::getItemURL('link',null,$sid);
				break;
			case self::VIEW_WEBCATEGORIES:
			default:
				$redirectUrl = LinkdirectoryURL::getCatURL('categories',null,$sid);
		}
		$this->setRedirect(JRoute::_($redirectUrl,false),$msg);
	}	
	
	private function mapSourceToRedirectUrl($default){
		$source = JRequest::getString('source','');
		if ($source == '' ) $source = $default;	
		switch ($source) {
			case self::VIEW_WEBLINK:
				return self::URL_WEBLINK;
			case self::VIEW_WEBCATEGORIES:
				return self::URL_WEBCATEGORIES;
			default:
				// TODO Überprüfen, wie Fehler hier behandelt werden können
				echo "source [$source] nicht unterstützt";
					
		}
	}


	/**
	 * Überprüfung, ob das Rating-Form angezeigt werden darf. 
	 *
	 */
	public function rate(){
		$ld = new LDConfig();
		try {
			$row = &$this->loadLinkRow();
			$serviceEnable = $ld->ratelink;
			$needLogin = ! $ld->gaddrate;
			$onlyOnce = $ld->rateonce;
			if ($this->checkLog($row,$serviceEnable,$needLogin,$onlyOnce,'vote')){
				$this->display();
			} 
		} catch (Exception $e) {
			return;
		}
		return;
	}

	
	/**
	 * Überprüfung, ob das interne Kommentar-Form angezeigt werden darf. 
	 *
	 */
	public function comment(){
		$ld = new LDConfig();
		try {
			$row = &$this->loadLinkRow();
			$serviceEnable = $ld->commentlink && ($ld->commentSystem =='intern');
			$needLogin = ! $ld->gaddcom;
			$onlyOnce = $ld->writeonce;
			if ($this->checkLog($row,$serviceEnable,$needLogin,$onlyOnce,'comment')){
				$this->display();
			}
		} catch (Exception $e) {
			return;
		}
		return;
	}

	/**
	 * Überprüft, ob die Aktion  $action erlaubt ist.
	 *
	 * @param int $row Link selbst
	 * @param boolean $serviceEnable true, wenn Service Enable ist
	 * @param boolean $needLogin true, wenn Login erforderlich ist
	 * @param boolean $onlyOnce true, wenn pro User die Aktion nur einmal erlaubt ist.
	 * @param String $action Aktion, z.Z. vote und comment erlaubt
	 * @return true, wenn AKtion erlaubt ist, sonst false und entsprechend gesetztem Redirect
	 */
	private function checkLog(&$row,$serviceEnable,$needLogin,$onlyOnce,$action){
		# User IP Address und User beschaffen
		$vote_ip = getenv( 'REMOTE_ADDR' );
		$user = &JFactory::getUser();

		// TODO Test, ob Categorie veröffentlich ist, fehlt noch
		if (empty($row)|| $row->published != 1) {
			// Link does not exists, or is not published
			$this->setRedirect(JRoute::_(LinkdirectoryURL::getCatURL('categories',null),false), JText::_('INVALID LINK OR LINK IS NOT PUBLISHED' ));
			return false;
		}

		if ( $serviceEnable == false ) {
			# Service not enable
			$this->setRedirect(JRoute::_(LinkdirectoryURL::getItemUrl('link',null,$row->id),false), JText::_('SERVICE NOT ENABLE') );
			return false;
		}

		if ( ($needLogin == true) && ($user->id < 1)) {
			# User is not logged in
			$this->setRedirect(JRoute::_(LinkdirectoryURL::getItemUrl('link',null,$row->id),false), JText::_('LD_LOGIN_FIRST') );
			return false;
		}

		if ( !$onlyOnce){
			return true;
		}

		$logModel = new LinkDirectory2ModelLog($action);
		$voted = $logModel->getHasUserLogEntryForLink($row->id);
		if ( !$voted ) {
			return true;
		}
		switch ($action){
			case 'vote':
				$message=JText::_('LD RATE BEFORE'); 
				break;
			case 'comment':
				$message=JText::_('LD_COMMENT_BEFORE'); 
				break;
			default:
				$message=JText::_('Internal error');
		}
		$this->setRedirect(JRoute::_(LinkdirectoryURL::getItemUrl('link',null,$row->id),false), $message );
		return false;
	}

	public function addRate(){
		
		$mainframe = JFactory::getApplication();
		require_once JPATH_COMPONENT.DS.'classes'.DS.'CaptchaUtils.php';
		$reloadPage = false;
		$checkSecurity = CaptchaUtils::validateCaptcha();
		if (!$checkSecurity) {
			$mainframe->enqueueMessage(JText::_('LD_LINK_REFUSED'));
			$reloadPage = true;
			JRequest::setVar( 'view'  , 'link' );
			JRequest::setVar( 'task'  , 'rate' );
			parent::display();
			return;
		}
		$rating = JRequest::getInt( 'rating', 0 );
		try {
			$row = &$this->loadLinkRow();
			$ld = new LDConfig();
			$serviceEnable = $ld->ratelink;
			$needLogin = ! $ld->gaddrate;
			$onlyOnce = $ld->rateonce;
			if (! $this->checkLog($row,$serviceEnable,$needLogin,$onlyOnce,'vote')){
				return;
			}

			if ( $rating == 0 ) {
				$this->setRedirect(JRoute::_(LinkdirectoryURL::getItemUrl('link','rate',$row->id),false), JText::_('LD_CHOOSE_RATE' ));
				return;
			}

			if ( $ld->rateonce) {
				$logModel = new LinkDirectory2ModelLog('vote');
				$logModel->updateLog($row->id);
			}

			$model = $this->getModel('link');

			if ($model->updateRating($row->id,$rating)) {
				$msg = JText::_( 'LD RATE SUCCESS' );
			} else {
				$msg = JText::_( 'LD RATE FAILED' );
			}
			$this->setRedirect(JRoute::_(LinkdirectoryURL::getItemUrl('link',null,$row->id),false), $msg);
		} catch (Exception $e){
			return;
		}
	}

	/**
	 * Fügt ein neurn Kommentar hinzu
	 *
	 */
	public function addComment(){
		$mainframe = JFactory::getApplication();
		require_once JPATH_COMPONENT.DS.'classes'.DS.'CaptchaUtils.php';
		$reloadPage = false;
		$checkSecurity = CaptchaUtils::validateCaptcha();
		if (!$checkSecurity) {
			$mainframe->enqueueMessage(JText::_('LD_LINK_REFUSED'));
			$reloadPage = true;
		}
		
		// Test, ob schon kommentiert, nur für "normale" Kommentare
		if (JRequest::getInt('type', 0) == 0){
			try {
				$weblink = &$this->loadLinkRow();
				$ld = new LDConfig();
				$serviceEnable = $ld->commentlink && ($ld->commentSystem =='intern');
				$needLogin = ! $ld->gaddcom;
				$onlyOnce = $ld->writeonce;			
				if (! $this->checkLog($weblink,$serviceEnable,$needLogin,$onlyOnce,'comment')){
					return;
				}
			} catch (Exception $e){
				return;
			}
		}

		// Kommentar aus Request hohlen
		$post	= JRequest::get('post');
		$comment = & JTable::getInstance('ldcomment','Table');
		if (!$comment->bind(JRequest::get('post'))) {
			JError::raiseError( 500, $db->stderr() );
			return false;
		}

		// Für "Bad Link Report" Titel setzen
		switch ($comment->type){
			case 1:
			case 2:
			case 3:
			case 4:
				$comment->rev_title=JText::_('LD_R'.$comment->type);
				break;
			case 0:
			default:
				break;
		}
		
		// Alle Pflichtfelder für neue Kommentar ?
		if (!$comment->check()){
			if ($comment->getError());
			$mainframe->enqueueMessage($comment->getError() == '' ? JText::_('LD_MISSING_A_FIELD') : $comment->getError());
			$reloadPage = true;
		}

		// Formular erneut mit den ausgefüllten Daten zeigen, wenn nicht alle nötigen Felder belegt waren oder das Captcha
		// falsch gelöst worden ist.
		if ($reloadPage){
			JRequest::setVar( 'view'  , 'link' );
			switch ($comment->type){
				case 1:
				case 2:
				case 3:
				case 4:
					JRequest::setVar( 'task'  , 'report' );
					break;
				case 0:
				default:
					JRequest::setVar( 'task'  , 'comment' );
					break;;
			}
			parent::display();
			return;
		}

		// Kommentar speichern und ggf. Log schreiben
		$model = new LinkDirectory2ModelLdcomment();
		if ($model->store($comment)) {
			// TODO Modell so anpassen, das ggf. die Medlung so mit dem "Published-Status" erweitert werden kann,
			$msg = JText::_( 'Comment Saved' );
			if ( $ld->rateonce && ($comment->type == 0) ) {
				$logModel = new LinkDirectory2ModelLog('comment');
				$logModel->updateLog($weblink->id);
			}	
		} else {
			$msg = JText::_( 'Error Saving Comment' );
		}
		$this->setRedirect(JRoute::_(LinkdirectoryURL::getItemUrl('link',null,$comment->link_id),false), $msg );
	}
	
	
	// =======================================================================================
	// =                           HELPER                                                    =
	// =======================================================================================
	/**
	 * Liefert den Weblink  mit der Id, die aus dem Request ermittel wird
	 * Bei einem Fehler wird der Redirect auf die "Startseite" gesetzt und eine Exception geworfen
	 *
	 * @return Link mit der id aus dem Rquest
	 * @throws Exception, wenn die Zeile mit der Id des Request nicht
	 *         gefunden worden ist.
	 */
	private function &loadLinkRow(){
		$db = JFactory::getDBO();
		JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR . DS . 'tables');
		$row =& JTable::getInstance('weblink', 'Table');
		$id = JRequest::getInt('id');
		$row->load($id);
		if ($row === false || $row->title === null){	
			$this->setRedirect(JRoute::_(self::URL_ROOT,false),JText::_('INVALID LINK OR LINK IS NOT PUBLISHED'),'error');
			throw new Exception("Can't find Link with id [$id]");
		}
		return $row;
	}
	
}
?>
