<?php defined('_JEXEC') or die('Restricted access');

/**
 * @version 2.0 $Id: default.php,v 1.21 2010-02-17 21:35:38 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

require_once(JPATH_COMPONENT.DS.'classes'.DS.'LinkdirectoryURL.php');

class HtmlRow {
	private $_htmlColumnCounter = 0;
	private $_amountColumn = 0;
	private $_sublimit = 0;
	
	public function __construct($amountColumn,$maxSubCategories){
		$this->_htmlColumnCounter = 0;
		$this->_amountColumn = $amountColumn;
		$this->_maxSubCategories = $maxSubCategories;
	}

	public function displayRowBegin(){
		if ($this->_htmlColumnCounter==0) { ?>
			<tr>
			<?php 
		}
	}
	
	public function displayRowEnd(){
		$this->_htmlColumnCounter++;
		if ($this->_amountColumn == $this->_htmlColumnCounter) {?>
			</tr><?php
			$this->_htmlColumnCounter = 0;
		}
	}

	/**
	 * Ausgabe der Subkategorien, wenn diese angezeigt werden sollen. 
	 *
	 * @param int_type $subcategories
	 * @param int $sublimit Maximale Anzahl der anzuzeigenden SubKategorien 
	 */
	public function displaySubCategories (&$subcategories){
		if ($this->_maxSubCategories >0){
			$amountSubCategories = count( $subcategories );
			if (($amountSubCategories > 0) && ($amountSubCategories > $this->_maxSubCategories)) {
				array_pop($subcategories);
				$amountSubCategories = $this->_maxSubCategories;
				$row  = $subcategories[0];
				$readMorelink = LinkdirectoryURL::getCatURL('categories', null, $row->parent_id);
				
				$msg=JText::_('READMORE');
				$extraHTMLforReadMore='<a href="'.$readMorelink.'">'.$msg.'</a>';
			} else {
				$extraHTMLforReadMore='';
			} ?>
			
			<div class="navcontainer">
			<ul class="navlist"> 
			<?php
			foreach($subcategories as $subcategory){
				$link = LinkdirectoryURL::getCatURL('categories', null, $subcategory->id);
				?><li><a href="<?php echo $link; ?>"><?php echo $subcategory->name; ?></a></li><?php
			}
			if ($extraHTMLforReadMore){
				?><li><?php echo $extraHTMLforReadMore ?></li><?php
			}
			?>
			</ul>
			</div> 
			<?php			
		}
	}
}

$html=new HtmlRow($this->amountCategoryColumns, $this->maxSubCategories);

if (count($this->rows_of_category)) {
	?>
<table width="100%" border="0 ">
	<?php
	$widthPerColumn = intval(100/ $this->amountCategoryColumns).'%';
	foreach ($this->rows_of_category as $row){
		$link = JRoute::_(LinkdirectoryURL::getCatURL('categories',null, $row->id));
		$html->displayRowBegin();
	?>
		<td width="<?php echo $widthPerColumn;?>" valign="top" align="center">
	<?php if ($row->image){
		if ( $row->image['link'] ){ ?>
			<a href="<?php echo $row->image['link'];?>"><?php 
		}?><img 
			src="<?php echo $row->image['src'];?>" border="0" alt="<?php echo $row->image['alt']; ;?>" />
		<?php if ( $row->image['link'] ){ ?>
			</a><?php 
		}?>
		<br />
	<?php } 
		if ($row->linksOrSubCategoriesAvailable){
		?> <a 
			href="<?php echo $link;?>"><span class="ld_mainCat"><?php echo $row->name;?></span></a>&nbsp;<?php
		} else {
			?><span class="ld_mainCatNonLink"><?php echo $row->name;?></span>&nbsp;<?php
		}		
		
		echo $row->totalLinkAndSubCatHtml; 
		echo $row->descriptionHtml;
		?> <br />
			<?php $html->displaySubCategories($row->subCategories); ?><br />
			<br />
		</td>
		<?php
		$html->displayRowEnd();
	}
?>
</table>
<?php
}
?>
