<?php defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * @version 2.0 $Id: default_links.php,v 1.24 2010-03-25 22:56:09 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

require_once(JPATH_COMPONENT.DS.'classes'.DS.'LinkdirectoryURL.php');
require_once(JPATH_COMPONENT.DS.'classes'.DS.'ThumbnailUtils.php');
require_once(JPATH_COMPONENT.DS.'classes'.DS.'LinkHtmlUtils.php');
require_once(JPATH_COMPONENT.DS.'classes'.DS.'RatingHtmlUtils.php');
require_once(JPATH_COMPONENT.DS.'classes'.DS.'CommentHtmlUtils.php');

/**
 * Ausgabe eines Trennzeichen
 *
 * @param bool $firstItem true, wenn erstes Feld ausgegeben wurde, sonst false
 * @return Trennzeichen ' | ' oder ''
 */
function getTrenner(&$firstItem){
	if ($firstItem){
		$firstItem=false;
	} else {
		return ' | ';
	}
	return '';
}

/**
 * Ausgabe der URL des Links. Bei showfastlink gleich true 
 * und wenn die Detail-Seite nicht ausgegeben werden muss,
 * wird die URL des Link selbst zurückgegeben, ansonsten die URL der Detail-Seite.
 * 
 * Wird die URL selbts zurückgegeben, wird diese um [" target="_blank] ergänzt. 
 *
 * @param Object $tthis (->showfastlink und ->needDetailPage) 
 * @param String $link URL des Links selbst
 * @param String $urlToDetailPage URL zur Detail-Seite
 */
function echoTitleUrl ($tthis,&$link,&$urlToDetailPage){
	if ($tthis->showfastlink ) { 
    	echo LinkdirectoryURL::getUrlToLink($link->url,$link->id); 
    	echo '" target="_blank'; 
	} else {
		if ( $tthis->needDetailPage){
			echo $urlToDetailPage;
		} else {
			echo LinkdirectoryURL::getUrlToLink($link->url,$link->id); 
    		echo '" target="_blank';
		}	
	}
}
?>

<div  id="ldlinklist">
<table width="100%" border="0" class="linktable" cellpadding="0" cellspacing="0">
<?php if (($this->ldshowcatonlist) && (!$this->searchtext) && ($this->parentDescription))  { ?>
  <!-- Categorie Description -->
  <tr class="catdesc">
    <td class="catdesc" colspan="2"><?php echo stripslashes($this->parentDescription); ?></td>
  </tr>
  <!-- Category Description -->
  <?php } ?>
<?php
$ldThumbnailService = new ThumbnailUtils();
if (count($this->rows_of_links)) {
	$k = 0;

	for ($i=0, $n=count( $this->rows_of_links ); $i < $n; $i++) {
		$link = &$this->rows_of_links[$i];
		$url =        LinkdirectoryURL::getItemUrl('link',null, $link->id);
		$rateurl =    LinkdirectoryURL::getItemUrl('link','rate',   $link->id);
		if ($this->commentSystem == 'jcomment'){
			$commenturl = LinkdirectoryURL::getItemUrl('link',null, $link->id);
		} else {
			$commenturl = LinkdirectoryURL::getItemUrl('link','comment',$link->id);
		}
		
		$reporturl =  LinkdirectoryURL::getItemUrl('link','report', $link->id);
		$description= LinkHtmlUtils::getDescription($link,$this->showlongdescription);
		$totalComments = CommentHtmlUtils::getTotalComment($link->id);
		if (isset($this->found)){
			$caturl = LinkdirectoryURL::getCatURL('categories', null, $link->catid);
		}
		$linkThumbImage = $ldThumbnailService->getThumbForLink($link);
		?>
  <tr class="<?php echo $this->tabclass[$k]; ?>">
    <td class="linktitle"><a href="<?php echoTitleUrl($this,$link,$url)?>" class="title"><?php echo $link->title;?></a></td>
    <td class="linktitlecat"><?php /* TODO Kategorie einpflegen */if (isset($this->found)) {?><a href="<?php echo $caturl; ?>"> <?php echo $link->category_name;?></a><?php } ?></td>
  </tr>
  <tr>
    <td class="linkdesc" colspan="2"><?php echo $linkThumbImage; echo $description;?></td>
  </tr>
  <?php if (($this->ratelink) || ($this->commentlink) || ($this->showhits) || ($this->ldshowlinkadd)) {?>
  <tr>
    <td class="linkoption" colspan="2">
    <div class="navcontainerLinkDetails">
		<ul class="navlist">
    <?php if ($this->needDetailPage) { ?><li><a href="<?php echo $url;?>"><?php echo JText::_('LD VIEW DETAILS'); ?></a></li><?php } ?>
    <?php if ($this->ldshowlinkadd) { ?><li><?php echo $link->created; }?></li> 
    <?php if ($this->ratelink) { ?><li><?php echo RatingHtmlUtils::show($link->rating, $link->votes);?> <a href="<?php echo $rateurl;?>"><?php echo $link->votes;?> <?php echo JText::_('LD_VOTES');?></a><?php } ?> 
    <?php if ($this->commentlink) { ?><li><a href="<?php echo $commenturl;?>"><?php echo $totalComments;?> <?php echo JText::_('LD VIEW COMMENTS');?></a></li><?php } ?>
    <?php if ($this->badlink) { ?><li><a href="<?php echo $reporturl;?>"><?php echo JText::_('LD REPORT BADWEBLINK');?></a></li><?php } ?>
    <?php if ($this->showhits) {?><li><?php echo $link->hits;?> <?php echo JText::_('LD_HITS'); }?></li>
    	</ul>
    	</div>
    </td>
  </tr>
  <?php } 
		$k = 1 - $k;
	}
}
?>
</table>

<!-- Page navigation -->
<?php if ($this->paginationLinks) {  ?>
<div class="pagination">
<table width="100%" class="navtable">
	<tr>
		<td class="navtable"><?php echo $this->paginationLinks->getPagesLinks(); ?></td>
	</tr>
	<tr>
		<td class="navtable"><?php echo $this->paginationLinks->getPagesCounter(); ?></td>
	</tr>
</table>
</div>
<!-- Page navigation -->
<?php
	} 
?>
<!-- Link Thumb Back Link -->
<?php if ($ldThumbnailService->isLinkThumbEnable()) {  ?>
<table width="100%" class="navtable">
	<tr>
		<td class="navtable"><?php echo $ldThumbnailService->getBackLinkForLinkThumb(); ?></td>
	</tr>
</table>

<!-- Link Thumb Back Link -->
<?php
	} 
?>
</div>
